// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "OleTest.h"
#include "DlgProxy.h"
#include "OleTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COleTestDlgAutoProxy

IMPLEMENT_DYNCREATE(COleTestDlgAutoProxy, CCmdTarget)

COleTestDlgAutoProxy::COleTestDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an OLE automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(COleTestDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (COleTestDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

COleTestDlgAutoProxy::~COleTestDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with OLE automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	AfxOleUnlockApp();
}

void COleTestDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(COleTestDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(COleTestDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(COleTestDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(COleTestDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IOleTest to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {CD4FFCE6-7476-11D2-BD6D-444553540000}
static const IID IID_IOleTest =
{ 0xcd4ffce6, 0x7476, 0x11d2, { 0xbd, 0x6d, 0x44, 0x45, 0x53, 0x54, 0x0, 0x0 } };

BEGIN_INTERFACE_MAP(COleTestDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(COleTestDlgAutoProxy, IID_IOleTest, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {CD4FFCE4-7476-11D2-BD6D-444553540000}
IMPLEMENT_OLECREATE2(COleTestDlgAutoProxy, "OleTest.Application", 0xcd4ffce4, 0x7476, 0x11d2, 0xbd, 0x6d, 0x44, 0x45, 0x53, 0x54, 0x0, 0x0)

/////////////////////////////////////////////////////////////////////////////
// COleTestDlgAutoProxy message handlers
